const { getProjectPath, isExistsSyncFile } = require('./utils');
const appWebpackConfigPath = getProjectPath('/config/app.webpack.js');

module.exports = function extendWebpackConfigFromProject(
  resultCallback,
  appConfig,
  extendEnv,
  { isProd, isServer, isHotServer }
) {
  const result = resultCallback(appConfig, extendEnv, { isProd, isServer, isHotServer });
  if (isExistsSyncFile(appWebpackConfigPath)) {
    const extendConfig = require(appWebpackConfigPath);
    if (typeof extendConfig !== 'function') {
      throw Error(
        `Extend webpack config file only functions are supported and return extend result! \n current type is ${typeof extendConfig} \n filename is ${appWebpackConfigPath}`
      );
    }
    const extendResult = extendConfig(result, appConfig, extendEnv, {
      isProd,
      isServer,
      isHotServer
    });
    if (!extendResult) {
      throw Error(
        `Return extend result! \n current extendResult is ${extendResult} \n filename is ${appWebpackConfigPath}`
      );
    }
    return extendResult;
  }
  return result;
};
